Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.tools.tar
Class TarEntry

    java.lang.Object
      |
      +--org.apache.tools.tar.TarEntry

All Implemented Interfaces:
  TarConstants

public class TarEntry
extends java.lang.Object
implements TarConstants

This class represents an entry in a Tar archive. It consists of the entry's header, as well as the entry's File. Entries can be instantiated in one of three ways, depending on how they are to be used.

TarEntries that are created from the header bytes read from an archive are instantiated with the TarEntry( byte[] ) constructor. These entries will be used when extracting from or listing the contents of an archive. These entries have their header filled in using the header bytes. They also set the File to null, since they reference an archive entry not a file.

TarEntries that are created from Files that are to be written into an archive are instantiated with the TarEntry( File ) constructor. These entries have their header filled in using the File's information. They also keep a reference to the File for convenience when writing entries.

Finally, TarEntries can be constructed from nothing but a name. This allows the programmer to construct the entry by hand, for instance when only an InputStream is available for writing to the archive, and the header information is constructed from other information. In this case the header fields are set to defaults and the File is set to null.

The C structure for a Tar Entry's header is:

     struct header {
     char name[NAMSIZ];
     char mode[8];
     char uid[8];
     char gid[8];
     char size[12];
     char mtime[12];
     char chksum[8];
     char linkflag;
     char linkname[NAMSIZ];
     char magic[8];
     char uname[TUNMLEN];
     char gname[TGNMLEN];
     char devmajor[8];
     char devminor[8];
     } header;

Author:
  Timothy Gerard Endres time@ice.com, Stefano Mazzocchi stefano@apache.org

Fields inherited from interface org.apache.tools.tar.TarConstants
`CHKSUMLEN, DEVLEN, GIDLEN, GNAMELEN, GNU_LONGLINK, GNU_TMAGIC, LF_BLK, LF_CHR, LF_CONTIG, LF_DIR, LF_FIFO, LF_GNUTYPE_LONGNAME, LF_LINK, LF_NORMAL, LF_OLDNORM, LF_SYMLINK, MAGICLEN, MODELEN, MODTIMELEN, NAMELEN, SIZELEN, TMAGIC, UIDLEN, UNAMELEN`

Constructor Summary
`TarEntry(byte[] headerBuf)` Construct an entry from an archive's header bytes.
`TarEntry(java.io.File file)` Construct an entry for a file.
`TarEntry(java.lang.String name)` Construct an entry with only a name.
`TarEntry(java.lang.String name, byte linkFlag)` Construct an entry with a name an a link flag.

Method Summary
`boolean` | `equals(TarEntry it)` Determine if the two entries are equal.
`TarEntry[]` | `getDirectoryEntries()` If this entry represents a file, and the file is a directory, return an array of TarEntries for this entry's children.
`java.io.File` | `getFile()` Get this entry's file.
`int` | `getGroupId()` Get this entry's group id.
`java.lang.String` | `getGroupName()` Get this entry's group name.
`java.util.Date` | `getModTime()` Set this entry's modification time.
`java.lang.String` | `getName()` Get this entry's name.
`long` | `getSize()` Get this entry's file size.
`int` | `getUserId()` Get this entry's user id.
`java.lang.String` | `getUserName()` Get this entry's user name.
`boolean` | `isDescendent(TarEntry desc)` Determine if the given entry is a descendant of this entry.
`boolean` | `isDirectory()` Return whether or not this entry represents a directory.
`boolean` | `isGNULongNameEntry()` Indicate if this entry is a GNU long name block
`void` | `parseTarHeader(byte[] header)` Parse an entry's header information from a header buffer.
`void` | `setGroupId(int groupId)` Set this entry's group id.
`void` | `setGroupName(java.lang.String groupName)` Set this entry's group name.
`void` | `setIds(int userId, int groupId)` Convenience method to set this entry's group and user ids.
`void` | `setMode(int mode)` Set the mode for this entry
`void` | `setModTime(java.util.Date time)` Set this entry's modification time.
`void` | `setModTime(long time)` Set this entry's modification time.
`void` | `setName(java.lang.String name)` Set this entry's name.
`void` | `setNames(java.lang.String userName, java.lang.String groupName)` Convenience method to set this entry's group and user names.
`void` | `setSize(long size)` Set this entry's file size.
`void` | `setUserId(int userId)` Set this entry's user id.
`void` | `setUserName(java.lang.String userName)` Set this entry's user name.
`void` | `writeEntryHeader(byte[] outbuf)` Write an entry's header information to a header buffer.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### TarEntry

    public TarEntry(java.lang.String name)

  Construct an entry with only a name. This allows the programmer to construct the entry's header "by hand". File is set to null.

### TarEntry

    public TarEntry(java.lang.String name,
                    byte linkFlag)

  Construct an entry with a name an a link flag.

### TarEntry

    public TarEntry(java.io.File file)

  Construct an entry for a file. File is set to file, and the header is constructed from information from the file.
  Parameters:
    `file` - The file that the entry represents.

### TarEntry

    public TarEntry(byte[] headerBuf)

  Construct an entry from an archive's header bytes. File is set to null.
  Parameters:
    `headerBuf` - The header bytes from a tar archive entry.

Method Detail

### equals

    public boolean equals(TarEntry it)

  Determine if the two entries are equal. Equality is determined by the header names being equal.
  Returns:
    it Entry to be checked for equality.

### isDescendent

    public boolean isDescendent(TarEntry desc)

  Determine if the given entry is a descendant of this entry. Descendancy is determined by the name of the descendant starting with this entry's name.
  Parameters:
    `desc` - Entry to be checked as a descendent of this.
  Returns:
    True if entry is a descendant of this.

### getName

    public java.lang.String getName()

  Get this entry's name.
  Returns:
    This entry's name.

### setName

    public void setName(java.lang.String name)

  Set this entry's name.
  Parameters:
    `name` - This entry's new name.

### setMode

    public void setMode(int mode)

  Set the mode for this entry

### getUserId

    public int getUserId()

  Get this entry's user id.
  Returns:
    This entry's user id.

### setUserId

    public void setUserId(int userId)

  Set this entry's user id.
  Parameters:
    `userId` - This entry's new user id.

### getGroupId

    public int getGroupId()

  Get this entry's group id.
  Returns:
    This entry's group id.

### setGroupId

    public void setGroupId(int groupId)

  Set this entry's group id.
  Parameters:
    `groupId` - This entry's new group id.

### getUserName

    public java.lang.String getUserName()

  Get this entry's user name.
  Returns:
    This entry's user name.

### setUserName

    public void setUserName(java.lang.String userName)

  Set this entry's user name.
  Parameters:
    `userName` - This entry's new user name.

### getGroupName

    public java.lang.String getGroupName()

  Get this entry's group name.
  Returns:
    This entry's group name.

### setGroupName

    public void setGroupName(java.lang.String groupName)

  Set this entry's group name.
  Parameters:
    `groupName` - This entry's new group name.

### setIds

    public void setIds(int userId,
                       int groupId)

  Convenience method to set this entry's group and user ids.
  Parameters:
    `userId` - This entry's new user id.
    `groupId` - This entry's new group id.

### setNames

    public void setNames(java.lang.String userName,
                         java.lang.String groupName)

  Convenience method to set this entry's group and user names.
  Parameters:
    `userName` - This entry's new user name.
    `groupName` - This entry's new group name.

### setModTime

    public void setModTime(long time)

  Set this entry's modification time. The parameter passed to this method is in "Java time".
  Parameters:
    `time` - This entry's new modification time.

### setModTime

    public void setModTime(java.util.Date time)

  Set this entry's modification time.
  Parameters:
    `time` - This entry's new modification time.

### getModTime

    public java.util.Date getModTime()

  Set this entry's modification time.
  Parameters:
    `time` - This entry's new modification time.

### getFile

    public java.io.File getFile()

  Get this entry's file.
  Returns:
    This entry's file.

### getSize

    public long getSize()

  Get this entry's file size.
  Returns:
    This entry's file size.

### setSize

    public void setSize(long size)

  Set this entry's file size.
  Parameters:
    `size` - This entry's new file size.

### isGNULongNameEntry

    public boolean isGNULongNameEntry()

  Indicate if this entry is a GNU long name block
  Returns:
    true if this is a long name extension provided by GNU tar

### isDirectory

    public boolean isDirectory()

  Return whether or not this entry represents a directory.
  Returns:
    True if this entry is a directory.

### getDirectoryEntries

    public TarEntry[] getDirectoryEntries()

  If this entry represents a file, and the file is a directory, return an array of TarEntries for this entry's children.
  Returns:
    An array of TarEntry's for this entry's children.

### writeEntryHeader

    public void writeEntryHeader(byte[] outbuf)

  Write an entry's header information to a header buffer.
  Parameters:
    `outbuf` - The tar entry header buffer to fill in.

### parseTarHeader

    public void parseTarHeader(byte[] header)

  Parse an entry's header information from a header buffer.
  Parameters:
    `header` - The tar entry header buffer to get information from.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000 Apache Software Foundation. All Rights Reserved.